routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



//Auth::routes(['verify' => false,'register' => false]);

Route::get('/', function(){
	return redirect('login');
})->where(['url' => '|home'])->name('home');

if(env('API_URL')=="" || env('API_URL')==url('/')){
	Auth::routes(['register'=>false]);
	Route::get('index', 'HomeController@index')->name('index');
}

Route::group(['middleware' => ['frontend']], function(){	
	Route::get('/{url?}', 'HomeController@index')->where(['url' => '|home'])->name('home');
});

Route::group(['middleware' => ['auth']], function(){
	Route::get('access-denied', function(){
		return view('access-denied');
	})->name('access-denied');
        Route::resource('profile', 'ProfileController')->only(['index', 'store']);
		Route::group(['middleware' => ['check_permission'],'namespace'=>'Admin','prefix'=>'admin', 'as' => 'admin.'], function(){	

		Route::get('dashboard', 'DashboardController@index')->name('dashboard');
		Route::resource('profile', 'ProfileController')->only(['index', 'store']);
        Route::resource('settings', 'SettingsController')->only(['index', 'store']);

		// For Users
		Route::resources([
			'users' => 'UsersController',
		]);
		
        Route::post('users/getUsers', 'UsersController@getUsers')->name('users.getUsers');
		Route::get('users/status/{user_id}', 'UsersController@status')->name('users.status');	

       // For complainttype
		Route::resource('complainttype', 'ComplaintTypeController')->except(['show']);
		Route::post('complainttype/list', 'ComplaintTypeController@getComplaintType')->name('complainttype.getComplaintType');
		Route::get('complainttype/status/{id}', 'ComplaintTypeController@status')->name('complainttype.status');	

         // For roles
		Route::resource('roles','RoleController');
		Route::get('roles/destroy/{id}', 'RoleController@destroy')->name('roles.destroy');
		Route::get('roles/status/{id}', 'RoleController@status')->name('roles.status');
	
        // For Complaints
		Route::resource('complaints', 'ComplaintsController');
		Route::post('complaints/list', 'ComplaintsController@getComplaints')->name('complaints.getComplaints');
		Route::get('complaints/status/{id}', 'ComplaintsController@status')->name('complaints.status');
		Route::get('complaints/aprovelstatus/{id}', 'ComplaintsController@aprovelStatus')->name('complaints.aprovelstatus');	
		Route::get('complaints/rejectstatus/{id}', 'ComplaintsController@rejectStatus')->name('complaints.rejectStatus');	


		Route::resource('components','ComponentController');
    	Route::get('components/destroy/{id}', 'ComponentController@destroy')->name('components.destroy');
    	Route::get('components/status/{id}', 'ComponentController@status')->name('components.status');

    	Route::resource('vehicles','VehiclesController');
    	Route::post('vehicles/getVehicles', 'VehiclesController@getVehicles')->name('vehicles.getVehicles');
    	Route::get('vehicles/status/{id}', 'VehiclesController@status')->name('vehicles.status');

	});

});

app/Complaint.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Complaint extends Model
{
    protected $table = 'complaints';
    protected $fillable = [
        'user_id','location','reason','comments','evidence_image','evidence_voice','evidence_video','is_active','status'
    ];


    public function getuser(){
        return $this->belongsTo('App\User', 'user_id', 'id'); 
    }
}

app/ComplaintType.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;


class ComplaintType extends Model 
{    
    /**
     * The attributes that are mass assignable.
     *
     * @var array
    */
    protected $fillable = [
        'title','is_active','image'
    ];    

    // For default settings
    protected static function boot(){
	    parent::boot();
	    
	    // Order by name ASC
	    static::addGlobalScope('order', function ($query) {
	        $query->orderBy('title', 'ASC');
	    });
	}
    /**
     * Scope a query to only include users of a given type.
     *
     * @param  \Illuminate\Database\Eloquent\Builder  $query
     * @param  mixed  $type
     * @return \Illuminate\Database\Eloquent\Builder
     */
    // public function scopeOfCountry(){
    //     return $this->hasMany(City::class,'country_id');
    // }
}

app/Http/Controllers/API/ComplaintsController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Validator;
use Auth;
use File;
use App\Complaint;

class ComplaintsController extends Controller
{
   public function getAllComplaints(Request $request){
    try{
        $complaints=Complaint::where('is_active',true)->get();
        if(!empty($complaints)){
            $response['status'] = 200;
            $response['data'] = $complaints;
            $response['message'] = "Success";
            return response()->json($response);
        }
        else{
            $response['status'] = 204;
            $response['data'] = [];
            $response['message'] = "Success";
            return response()->json($response);
    
        }
    }catch (\Exception $e){
        $response['status'] = 500;
        $response['message'] = $e->getMessage();
        return response()->json($response);
    }
   }
   public function addComplaint(Request $request){
    try{
        $validator = Validator::make($request->all(),[ 
            'user_id' => 'required',
            'location' => 'required', 
            'reason' => 'required',
            'comments' => 'required',
            'evidence_image' => 'nullable|mimes:jpg,bmp,png,jpeg',
            'evidence_video' => 'nullable|mimetypes:video/mp4,video/avi,video/mpeg,video/quicktime| max:20000',
            ]);
        if($validator->fails()){ 
            return response()->json(['status'=>400,'message'=>$validator->errors()->first()]);            
        }
        $data = $request->all();
        // $user = Complaint::where('user_id',$request->user_id)->first();
        $evidence_image = $request->file('evidence_image');
        if($evidence_image){
            $path = public_path(config('constants.USERS_UPLOADS_PATH'));
            $evidence_imageName = time().'.'.$evidence_image->getClientOriginalExtension();
            File::isDirectory($path) or File::makeDirectory($path, 0777, true, true);
            $uploadResponse = $evidence_image->move($path, $evidence_imageName);
            if(isset($user->evidence_image) && $user->evidence_image!='' && file_exists($path.$user->evidence_image)){
                File::delete($path.$user->evidence_image);
            }
            $data['evidence_image'] = $evidence_imageName;
        }
        $evidence_video = $request->file('evidence_video');
        if($evidence_video){
            $path = public_path(config('constants.USERS_UPLOADS_PATH'));
            $evidence_videoName = time().'.'.$evidence_video->getClientOriginalExtension();
            File::isDirectory($path) or File::makeDirectory($path, 0777, true, true);
            $uploadResponse = $evidence_video->move($path, $evidence_videoName);
            if(isset($user->evidence_video) && $user->evidence_video!='' && file_exists($path.$user->evidence_video)){
                File::delete($path.$user->evidence_video);
            }
            $data['evidence_video'] = $evidence_videoName;
        }
        $data['is_active']=true;
        $data['status']=false;
        $complaint = Complaint::create($data);
        if($complaint){
            $response['status'] = 200;
            $response['data'] = $complaint;
            $response['message'] = "Complaint added successfully";
            return response()->json($response);
        }
        else{
            $response['status'] = 500;
            $response['message'] = "Some thing wrong please try again later.";
            return response()->json($response);
        } 
    }catch (\Exception $e){
        $response['status'] = 500;
        $response['message'] = $e->getMessage();
        return response()->json($response);
    }
   }
   public function getComplaint(Request $request){
    try{
        $validator = Validator::make($request->all(),[ 
            'id' => 'required', 
            ]);
        if ($validator->fails()){ 
            return response()->json(['status'=>400,'message'=>$validator->errors()->first()]);            
        }
        $id=$request->input("id");
        $complaint=Complaint::where('is_active',true)->where('id',$id)->first();
        if(!empty($complaint)){
            $response['status'] = 200;
            $response['data'] = $complaint;
            $response['message'] = "Success";
            return response()->json($response);
        }
        else{
            $response['status'] = 204;
            $response['data'] = [];
            $response['message'] = "Success";
            return response()->json($response);
        }
    }catch (\Exception $e) {
        $response['status'] = 500;
        $response['message'] = $e->getMessage();
        return response()->json($response);
    }
   }
   public function getUserComplaints(Request $request){
    try{
        $validator = Validator::make($request->all(),[ 
            'user_id' => 'required', 
            ]);
        if ($validator->fails()){ 
            return response()->json(['status'=>400,'message'=>$validator->errors()->first()]);            
        }
        $user_id=$request->input("user_id");
        $complaints=Complaint::where('is_active',true)->where('user_id',$user_id)->get();
        if(!empty($complaints)){
            $response['status'] = 200;
            $response['data'] = $complaints;
            $response['message'] = "Success";
            return response()->json($response);
        }
        else{
            $response['status'] = 204;
            $response['data'] = [];
            $response['message'] = "Success";
            return response()->json($response);
        }
    }catch (\Exception $e) {
        $response['status'] = 500;
        $response['message'] = $e->getMessage();
        return response()->json($response);
    }
   }
}

app/Http/Controllers/Admin/ComplaintsController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Complaint;
use DataTables;
use Form;
use Str;


class ComplaintsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        return view('admin.complaints.index');
    }

    public function getComplaints(Request $request){
        $complaint = Complaint::with('getuser')->select([\DB::raw(with(new Complaint)->getTable().'.*')])->groupBy('id');
        $status = $request->input('status');
        if($status !='')
        $complaint->where('is_active', $status);
        $aprovel_status = $request->input('aprovel_status');
        if($aprovel_status !='')
        $complaint->where('status',$aprovel_status);  
        
        
        return DataTables::of($complaint)               
            ->editColumn('user_id', function ($complaint){
                return $complaint->getuser->mobile_number;
            })
            ->editColumn('created_at', function ($complaint){
                return $complaint->created_at->diffForHumans();
            })
            ->editColumn('location', function ($complaint){
                return  Str::limit($complaint->location, 100);
            })
            ->editColumn('reason', function ($complaint){
                return Str::limit($complaint->reason, 100);
            })
            ->editColumn('comments', function ($complaint){
                return Str::limit($complaint->comments, 100);
            })  
            ->editColumn('evidence_image', function ($complaint){
                if($complaint->evidence_image){
                    $url=url('/uploads/users',$complaint->evidence_image);
                    return '<img style="max-height: 100px;max-width:100px;"  src="'.$url.'"/>';
                }
                return '';
              
            })
            ->editColumn('evidence_video', function ($complaint){
                if($complaint->evidence_video){
                    $url=url('/uploads/users',$complaint->evidence_video);
                    return '<video style="max-height:100px;max-width:100px;" src="'.$url.'" controls ></video>';  
                }
                return '';
              
            })
            ->editColumn('status', function ($complaint){
                if($complaint->status == false ){
                    return "<a href='".route('admin.complaints.rejectStatus',$complaint->id)."'><span class='btn btn-danger btn-sm'><i class='fas fa-times'></i></span></a>  <a href='".route('admin.complaints.aprovelstatus',$complaint->id)."'><span class='btn btn-success btn-sm'><i class='fas fa-check'></i></span></a>";
                }else{
                    if($complaint->status == 1 ){
                        return "<span class='badge badge-success'>Approved</span>";
                    }elseif($complaint->status == 2){
                        return "<span class='badge badge-danger'>Rejected</span>";
                    }
                    else{
                        return "<span class='badge badge-warning'>Pending</span>";
                    }
                }
            })
            ->editColumn('is_active', function ($complaint){
                if($complaint->is_active == TRUE ){
                    return "<a href='".route('admin.complaints.status',$complaint->id)."'><span class='badge badge-success'>Active</span></a>";
                }else{
                    return "<a href='".route('admin.complaints.status',$complaint->id)."'><span class='badge badge-danger'>Inactive</span></a>";
                }
            }) 
            ->addColumn('action', function ($complaint){
                return
                    // edit
                    // '<a href="'.route('admin.complaints.edit',[$complaint->id]).'" class="btn btn-success btn-circle btn-sm"><i class="fas fa-edit"></i></a> '.
                    // Delete
                    Form::open(array(
                        'style' => 'display: inline-block;',
                        'method' => 'DELETE',
                        'onsubmit'=>"return confirm('Do you really want to delete?')",
                        'route' => ['admin.complaints.destroy', $complaint->id])).
                    ' <button type="submit" class="btn btn-danger btn-circle btn-sm"><i class="fas fa-trash"></i></button>'.
                    Form::close();
            })
            ->rawColumns(['status','aprovel','is_active','action','evidence_image','evidence_video'])
            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request,Complaint $Complaint)
    {
        $Complaint->delete();
        $request->session()->flash('danger',__('global.messages.delete'));
        return redirect()->route('admin.complaints.index');
    }

    public function status(Request $request, $complaint_id=null){
        $complaint = Complaint::findOrFail($complaint_id);
        if (isset($complaint->is_active) && $complaint->is_active==FALSE) {
            $complaint->update(['is_active'=>TRUE]);
            $request->session()->flash('success',__('global.messages.activate'));
        }else{
            $complaint->update(['is_active'=>FALSE]);
            $request->session()->flash('danger',__('global.messages.deactivate'));
        }
        return redirect()->route('admin.complaints.index');
    }
    


    public function aprovelStatus(Request $request, $complaint_id=null){
        $complaint = Complaint::findOrFail($complaint_id);
            $complaint->update(['status'=>true]);
            $request->session()->flash('success',__('global.messages.approve'));
        return redirect()->route('admin.complaints.index');
    }
    public function rejectStatus(Request $request, $complaint_id=null){
        $complaint = Complaint::findOrFail($complaint_id);
            $complaint->update(['status'=>2]);
            $request->session()->flash('danger',__('global.messages.reject'));
        return redirect()->route('admin.complaints.index');
    }
   
}

resources/views/admin/complaints/form.blade.php
@extends('admin.layouts.valex_app')
@section('content')
<div class="container">
    <!-- Page Heading -->
    <div class="breadcrumb-header justify-content-between">
        <div class="left-content">
            <div>
              <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Market Survey</h2>
            </div>
        </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
            <div class="card">
                {!! Form::open(['method' => 'POST', 'route' => isset($complainttype->id)?['admin.complainttype.update',$complainttype->id]:['admin.complainttype.store'],'class' => 'form-horizontal','id' => 'frmCountry', 'files' => true]) !!}
                @csrf
                @if(isset($complainttype->id))
                @method('PUT')
                @endif
                <div class="card-header py-3 cstm_hdr">
                    <h6 class="m-0 font-weight-bold text-primary">{{ isset($complainttype->id)?'Edit':'Add' }} Type</h6>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="col-md-12 form-group {{$errors->has('title') ? config('constants.ERROR_FORM_GROUP_CLASS') : ''}}">
                                <label for="title">Title <span style="color:red">*</span></label>
                                {!! Form::text('title', old('title', isset($complainttype->title)?$complainttype->title:''), ['id'=>'title', 'class' => 'form-control', 'placeholder' => 'Title']) !!}

                                @if($errors->has('title'))
                                <p class="help-block">
                                    <strong>{{ $errors->first('title') }}</strong>
                                </p>
                                @endif
                            </div>                    
                                             
                        </div>
                    </div>
                </div>  
                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Submit</button>
                    <a href="{{route('admin.complainttype.index')}}"  class="btn btn-secondary">Cancel</a>
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection
@section('scripts')
<script type="text/javascript" src="{{ asset('js/jquery-validation/dist/jquery.validate.min.js') }}"></script>
<script type="text/javascript">
jQuery(document).ready(function(){
    jQuery('#frmCountry').validate({
        rules: {
            title: {
                required: true
            }          
        }
    });
});
</script>
@endsection

resources/views/admin/complaints/index.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/datatable/css/dataTables.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/buttons.bootstrap4.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/jquery.dataTables.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.dataTables.min.css')}}" rel="stylesheet">
@endsection

@section('content')
<!-- Begin Page Content -->
<div class="container">
  <div class="breadcrumb-header justify-content-between">
      <div class="left-content">
          <div>
            <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Complaints</h2>
          </div>
      </div>
  </div>
  <div class="row row-sm">
    <div class="col-xl-12">
      <div class="card">
        <div class="card-header py-3 cstm_hdr">
             <h6 class="m-0 font-weight-bold text-primary">Complaints</h6>
            <!-- <a href="{{route('admin.complainttype.create')}}" class="btn btn-sm btn-icon-split float-right btn-outline-warning">
                <span class="icon text-white-50">
                  <i class="fas fa-plus"></i>
                </span>
                <span class="text">Add Type</span>
            </a> -->
           
        </div>
        <div class="card-body">

        <div class="well mb-3">
                            {!! Form::open(['method' => 'POST', 'class' => 'form-inline', 'id' => 'frmFilter']) !!}
                            <?php if(Auth::user()->roles->first()->id == config('constants.ROLE_TYPE_SUPERADMIN_ID')){   ?>

                            <?php } ?>   
                    
                            <div class="form-group mr-sm-2 mb-2">
                                <select name="status" id="status" class="form-control">
                                    <option value="">-Select Status-</option>
                                    <option value="1">Active</option>
                                    <option value="0">Inactive</option>
                                </select>                
                            </div>
                            <div class="form-group mr-sm-2 mb-2">
                                <select name="aprovel_status" id="aprovel_status" class="form-control">
                                    <option value="">-Select Aprovel Status-</option>
                                    <option value="0">Pending</option>
                                    <option value="1">Approved</option>
                                    <option value="2">Rejected</option>
                                </select>                
                            </div>  
                            <button type="submit" class="btn btn-responsive btn-primary mr-sm-2 mb-2">{{ __('Filter') }}</button>
                            <a href="javascript:;" onclick="resetFilter();" class="btn btn-responsive btn-danger mb-2">{{ __('Reset') }}</a>
                            {!! Form::close() !!}
                    </div> 
            <div class="table-responsive">
                <table class="table table-bordered" width="100%" cellspacing="0" id="conplaints">
                    <thead>
                        <tr>
                            <th>Added By</th> 
                            <th>Added</th> 
                            <th>Location</th>           
                            <th>Reason</th>
                            <th>Comments</th> 
                            <th>Image</th>                       
                            <th>Video</th> 
                            <th>Approvel status</th>
                            <th>Status</th>
                            <th>Action</th> 
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                           <th>Added By</th> 
                            <th>Added</th> 
                            <th>Location</th>           
                            <th>Reason</th>
                            <th>Comments</th> 
                            <th>Image</th>                       
                            <th>Video</th> 
                            <th>Approvel status</th>
                            <th>Status</th>
                            <th>Action</th>                 
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
      </div>
    </div>
  </div>
</div>    
<!-- /.container-fluid -->
@endsection

@section('scripts')
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.bootstrap4.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/vfs_fonts.js') }}"></script>
<!-- export btn -->
<script type="text/javascript">
    jQuery(document).ready(function(){
        jQuery('#frmFilter :input:not(:button, [type="hidden"])').val('');
        getComplaints();
    });
    jQuery('#frmFilter').submit(function(){
        getComplaints();
        return false;
    });
    function resetFilter(){
    jQuery('#frmFilter :input:not(:button, [type="hidden"])').val('');
    getComplaints();
}
    function getComplaints(){        
        var status = jQuery('#frmFilter [name=status]').val();
        var aprovel_status = jQuery('#frmFilter [name=aprovel_status]').val();

        jQuery('#conplaints').dataTable().fnDestroy();
        jQuery('#conplaints tbody').empty();
        var table=jQuery('#conplaints').DataTable({
            processing: true,
            serverSide: true,
            iDisplayLength:50,
            ajax: {
                url: '{{ route('admin.complaints.getComplaints') }}',
                method: 'POST',
                data: {  
                status:status,
                aprovel_status:aprovel_status,
                }
            },
            lengthMenu: [
                [10, 25, 50, 100, -1],
                [10, 25, 50,100,"All"]
            ],
            columns: [              
                {data: 'user_id', name: 'user_id',class: 'text-center'},
                {data: 'created_at', name: 'created_at',class: 'text-center'},                
                {data: 'location', name: 'location',class: 'text-center'},             
                {data: 'reason', name: 'reason',class: 'text-center'},
                {data: 'comments', name: 'comments',class: 'text-center'},
                {data: 'evidence_image', name: 'evidence_image',class: 'text-center'},
                {data: 'evidence_video', name: 'evidence_video',class: 'text-center'},
                {data: 'status', name: 'status',"width": "10%",class: 'text-center'},
                {data: 'is_active', name: 'is_active', class: 'text-center',"width": "5%"},             
                {data: 'action', name: 'action', orderable: false, searchable: false ,class: 'text-center',"width": "5%"}
                           
            ],           
            order: [[0, 'asc']], 
            language: {
                searchPlaceholder: 'Search...',
                sSearch: '',
                lengthMenu: '_MENU_',
            },  
        }); 
    
    }      
</script>
@endsection